addHook('PlayerSpawn', function(p)
	if (p.isSpinning == nil) then
		p.isSpinning = false
	end

	if (p.dropdashing == nil) then
		p.dropdashing = false
	end

	if (p.dropdash == nil) then
		p.dropdash = false
	end

	if (p.dropDashSpeed == nil) then
		p.dropDashSpeed = 0
	end

	if (p.bounce == nil) then
		p.bounce = false
	end

	if (p.bouncing == nil) then
		p.bouncing = false
	end
end)

addHook('PlayerThink', function(p)
	if (p.mo.skin ~= 'poyo') then
		return
	end

	if (p.cmd.buttons & BT_SPIN) and not P_PlayerInPain(p) then
    if not (P_IsObjectOnGround(p.mo)) then
    	if p.dropdash == false then
  			S_StartSound(p.mo, sfx_spndsh)
    	end
			if p.bouncing == true then
				p.bouncing = false
			end
  		p.dropdash = true
  		p.mo.state = S_PLAY_SPINDASH
  		p.dropDashSpeed = (p.mo.momz / FRACUNIT) - ((p.mo.momz / FRACUNIT) * 2) * 2
	  elseif (P_IsObjectOnGround(p.mo)) and (p.dropdash == true) then
	  	p.dropdash = false
	  	if p.dropDashSpeed < 45 then
	  		p.dropDashSpeed = 45
	  	end
	    S_StartSound(p.mo, sfx_zoom)
	    P_InstaThrust(p.mo, p.mo.angle, p.speed+p.dropDashSpeed*FRACUNIT)
	    if (p.pflags & ~PF_SPINNING) then
				p.pflags = $|PF_SPINNING
	    end
  		p.mo.state = S_PLAY_ROLL
	    p.dropdashing = true
	    p.dropDashSpeed = 0
	  end
	elseif not (p.cmd.buttons & BT_SPIN) then
		if p.dropdash == true then
			p.dropdash = false
			p.dropDashSpeed = 0
		end
		if not (P_IsObjectOnGround(p.mo)) and (p.mo.state == S_PLAY_SPINDASH) then
			p.mo.state = S_PLAY_JUMP
		end
	end
	

	if (p.mo.state ~= S_PLAY_ROLL) and p.dropdashing then
		p.dropdashing = false
	end
end)