addHook('PlayerSpawn', function(p)
	if (p.canPressC2 == nil) then
		p.canPressC2 = true
	end
end)

addHook('PlayerThink', function(p)
	if (p.mo.skin ~= 'poyo') then
		return
	end

	if (p.cmd.buttons & BT_CUSTOM2) and (p.canPressC2 == true) and not (P_IsObjectOnGround(p.mo)) then
		p.canPressC2 = false
		p.mo.state = S_PLAY_ROLL
		P_SetObjectMomZ(p.mo, -28 * FRACUNIT)
		p.bouncing = true
		S_StartSound(p.mo, sfx_s23c)
	end

	if (p.mo.momz > 0 and p.bouncing == true) then
		p.bouncing = false
		p.mo.state = S_PLAY_JUMP
	end

	if (p.bouncing == true and not P_IsObjectOnGround(p.mo))
		p.dropDashSpeed = p.mo.momz
	end

	if (p.bouncing == true) and (P_IsObjectOnGround(p.mo)) then
		p.bounce = true
		p.pflags = $1|PF_JUMPED
		P_SetObjectMomZ(p.mo, -p.dropDashSpeed)
		S_StartSound(p.mo, sfx_s24c)
	end
	
	if not (p.cmd.buttons & BT_CUSTOM2) then
		p.canPressC2 = true
	end
end)